/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.extractors;

import it.eng.spago4q.bo.EOperation;
import it.eng.spago4q.dao.DAOFactory;
import it.eng.spago4q.dao.IES4QFKDAO;
import it.eng.spago4q.extractors.bo.GenericItemInterface;
import it.eng.spago4q.extractors.bo.InterfaceItem;
import it.eng.spago4q.extractors.script.ScriptExecutor;
import it.eng.spago4q.extractors.utilities.OperationUtil;
import it.eng.spago4q.testUtils.AbstractDBTestCase;

import java.util.List;

public class DefaultCoordinatorTest extends AbstractDBTestCase {

	private static final String FLAT_FILE = "test/flatFile/s4qFlatFile.xml";

	public DefaultCoordinatorTest(final String value) {
		super(value);
	}

	public void testExecute() {
		try {
 			ScriptExecutor scriptExecutor = new ScriptExecutor();
			
	        IES4QFKDAO operationDAO = (IES4QFKDAO) DAOFactory.getDAO("EOperationDAO");
	        EOperation operation = (EOperation)operationDAO.loadObjectById(2);
	        
	    	DomainValueCacheCreator domainValueCacheCreator = new DomainValueCacheCreator(
					operation.getInterfaceType().getId());

			List<GenericItemInterface> genericItemList = OperationUtil
					.executeOperation(operation);
			MapMaker mapMaker = new MapMaker();
			List<InterfaceItem> interfaceItem = mapMaker.mapping(operation,
					genericItemList, scriptExecutor, domainValueCacheCreator);
			assertEquals("Verify the number of interface Item extracted",1,interfaceItem.size());

		} catch (Exception e) {
			fail();
		}

	}

	protected String getFlatFile() {
		return FLAT_FILE;
	}

}
