/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 **/
package it.eng.spago4q.dataset;

import it.eng.spago.security.IEngUserProfile;
import it.eng.spagobi.kpi.config.bo.KpiValue;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

/**
 * SpagoBI Java Data Set that computes the average of the children of
 * the current modelInstance that is analyzed from the KPI Engine.
 * SpagoBIKpiInternalEngine
 */
public class S4QJavaDataSetAverage extends AbstractS4QJavaDataSet {

	private static transient Logger logger = Logger
			.getLogger(S4QJavaDataSetAverage.class);

	public String getValues(IEngUserProfile profile,Map map) {
		logger.info("IN");
		Integer numberOfChildren = 0;
		Double totalKpiChildrenValue = 0.0;
		Double toReturn = 0.0;
		List<KpiValue> values = getKpiValueOfModelInstanceChildren((HashMap)map);
		
		for (KpiValue kpiValue : values) {
			if (kpiValue.getValue() != null){
				totalKpiChildrenValue += new Double(kpiValue.getValue());
				numberOfChildren ++;
			}	
		}
		if (numberOfChildren != 0){
			toReturn = totalKpiChildrenValue / numberOfChildren;
			BigDecimal bd = new BigDecimal(toReturn);
			bd = bd.setScale(2,BigDecimal.ROUND_UP);
			toReturn = bd.doubleValue();
		}
		logger.info("OUT");
		return setDataSetResult(toReturn);
	}

	public List getNamesOfProfileAttributeRequired() {
		return null;
	}

}